// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      OmSourceParameters.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 16:49:17 MEST 2002

#ifndef OmSourceParameters_h
#define OmSourceParameters_h

#include "f90cxx.h"
#include "Dal.h"

#include <cstdlib>
#include <string>
// equivalent of f90::type(OmSourceParameter)
struct OmSourceParameter {
    OmSourceParameter() :
    number(0), 
    xcoord(0), 
    ycoord(0),
    stime(0),
    mtime (0),
    rightascension(0), 
    declination(0), 
    positionerror(0),
    exposure(0), 
    significance(0),
    rawcountrate(0), 
    rawcountrateerror(0),
    corrcountrate(0),
    corrcountrateerror(0), 
    magnitude(0),
    magnitudeerror(0),  
    rawbackgroundcountrate(0),
    rawbackgroundcountrateerror(0),
    corrbackgroundcountrate(0),
    corrbackgroundcountrateerror(0),
    psf1correction(0),
    psf2correction(0),
    coincidencecorrection(0), 
    tdscorrection(0), 
    semia(0),
    semiaerr(0),
    semib(0),
    semiberr(0),
    theta(0),  
    thetaerr(0), 
    photometryradius(0),   // was 0
    axialRatio(1.0),
    alpha(0.0), 
    innerbackgroundradius(0),
    outerbackgroundradius(0),
    nosourcepixels(0),
    extensionflag(0),
    confusionflag(0), 
    qualityflag(0),
    iMin(0), iMax(0), jMin(0), jMax(0) 

   {  }   

    int number; 
    float xcoord; 
    float ycoord;
    float stime;
    float mtime;
    double rightascension; 
    double declination;  
    float positionerror;
    float exposure; 
    float significance;
    float rawcountrate; 
    float rawcountrateerror;
    float corrcountrate;
    float corrcountrateerror;  //
    float magnitude;
    float magnitudeerror;  
    float rawbackgroundcountrate;
    float rawbackgroundcountrateerror;
    float corrbackgroundcountrate;
    float corrbackgroundcountrateerror;
    float psf1correction;
    float psf2correction;
    float coincidencecorrection;
    float tdscorrection;
    float semia;
    float semiaerr;
    float semib;
    float semiberr;
    float theta;  
    float thetaerr;
    float photometryradius;
    float axialRatio;
    float alpha;   
    float innerbackgroundradius;
    float outerbackgroundradius;
    int nosourcepixels;
 


    Integer1 extensionflag;  // was Integer2
    Integer1 confusionflag; 
    Integer2 qualityflag;
    Integer2 iMin; 
    Integer2 iMax; 
    Integer2 jMin; 
    Integer2 jMax; 
    char expId[4];
   };






#endif
