// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//#include<cpgplot.h>
#include "param.h"

#include<cmath>
#include"graph.h"
#include<iostream>
#include<vector>
#include <algorithm>
#include<numeric>
#include "Dal.h"
#include "utility.h"
#include "statistics.h"




vector<float> Graph::x1List, Graph::x2List, Graph::y1List, Graph::y2List;
vector<float> Graph::xminList, Graph::xmaxList, Graph::yminList, Graph::ymaxList;




/**************************************************
*
*
*
*************************************************/
void setFortranText(char *text)
{

  setParameter("plotfile", text);


}




int size = 513;

/********************************************************************
*
*
*********************************************************************/
void cbpglab(char *xlabel, char *ylabel, char *title )
{
  
 


    setParameter("plotfile", xlabel);

    F90MODPROC( pggraph_mod, setxlabel)();

  
    setParameter("plotfile", ylabel);

    F90MODPROC( pggraph_mod, setylabel)();


    setParameter("plotfile", title);

    F90MODPROC( pggraph_mod, settitle)();


    F90MODPROC( pggraph_mod, pglab1)();

}


/**************************************************************
*
*
***************************************************************/
void cbpgmtxt(const char *position, float x1, float x2, float x3, const char *label)
{

 
 

    setParameter("plotfile", position);

    F90MODPROC( pggraph_mod, settextposition)();


    setParameter("plotfile", label);

    F90MODPROC( pggraph_mod, setlabel)();



    F90MODPROC( pggraph_mod, pgmtxt1)(&x1, &x2, &x3);


}



/********************************************************************
*
*
*
*********************************************************************/
void cbpgpage()
{
    F90MODPROC( pggraph_mod, pgpage1)();

}


/********************************************************************
*
*
*
*********************************************************************/
void cbpgclos()
{
    F90MODPROC( pggraph_mod, pgclos1)();

}

/********************************************************************
*
*
*
*********************************************************************/
int cbpgopen(char *file)
{

    setParameter("plotfile", file);

    int k = F90MODPROC( pggraph_mod, pgopen1)();


    return k;
}




/********************************************************************
*
*
*********************************************************************/
void cbpgmove(float x, float y)
{
    F90MODPROC( pggraph_mod, pgmove1)(&x, &y);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgcirc(float x, float y, float radius)
{
    F90MODPROC( pggraph_mod, pgcirc1)(&x, &y, &radius);

}




/********************************************************************
*
*
*********************************************************************/
void cbpgdraw(float x, float y)
{
    F90MODPROC( pggraph_mod, pgdraw1)(&x, &y);

}
/**************************************************************
*
*
**************************************************************/
float cbpgrnd( float binWidth, int nSub )
{




  //  int k = F90MODPROC( pggraph_mod, pgopen1)();

    float f = F90MODPROC( pggraph_mod, pgrnd1)(&binWidth, &nSub);
    return f;


}



/********************************************************************
*
*
*********************************************************************/
void cbpgsubp(int x, int y)
{
    F90MODPROC( pggraph_mod, pgsubp1)(&x, &y);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgpanl(int x, int y)
{
    F90MODPROC( pggraph_mod, pgpanl1)(&x, &y);

}





/********************************************************************
*
*
*********************************************************************/
void cbpgrnge(float x1, float y1, float *x2, float *y2)
{
    F90MODPROC( pggraph_mod, pgrnge1)(&x1, &y1, x2, y2);

}



/********************************************************************
*
*
*********************************************************************/
void cbpgsvp(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgsvp1)(&x1, &x2, &y1, &y2);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgswin(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgswin1)(&x1, &x2, &y1, &y2);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgrect(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgrect1)(&x1, &x2, &y1, &y2);

}







/********************************************************************
*
*
*********************************************************************/
void cbpgwnad(float x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgwnad1)(&x1, &x2, &y1, &y2);

}



/********************************************************************
*
*
*********************************************************************/
void cbpgscr(int x1, float x2, float y1, float y2)
{
    F90MODPROC( pggraph_mod, pgscr1)(&x1, &x2, &y1, &y2);

}








/********************************************************************
*
*
*********************************************************************/
void cbpgline(int nData, float *x, float *y)
{
    F90MODPROC( pggraph_mod, pgline1)(&nData, x, y);

}
/********************************************************************
*
*
*********************************************************************/
void cbpgpt(int nData, float *x, float *y, int symbol)
{
  

    F90MODPROC( pggraph_mod, pgpt11)(&nData, x, y, &symbol);

}
/********************************************************************
*
*
*********************************************************************/
void cbpgpt1(float x, float y, int symbol)
{
    F90MODPROC( pggraph_mod, pgpt111)(&x, &y, &symbol);

}




/********************************************************************
*
*
*********************************************************************/
void cbpgerr1(int k, float x, float y, float error, int k1)
{
    F90MODPROC( pggraph_mod, pgerr11)(&k, &x, &y, &error, &k1);

}


/********************************************************************
*
*
*********************************************************************/
void cbpgerrx(int nData, float *x, float *y, float *error, int k)
{
    F90MODPROC( pggraph_mod, pgerrx1)(&nData, x, y, error, &k);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgerry(int nData, float *x, float *y, float *error, int k)
{
    F90MODPROC( pggraph_mod, pgerry1)(&nData, x, y, error, &k);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgsch(float size)
{
    F90MODPROC( pggraph_mod, pgschi1)(&size);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgsls(int style)
{
    F90MODPROC( pggraph_mod, pgsls1)(&style);

}



/********************************************************************
*
*
*********************************************************************/
void cbpgslw(int width)
{
    F90MODPROC( pggraph_mod, pgslw1)(&width);

}

/********************************************************************
*
*
*********************************************************************/
void cbpgsfs(int type)
{
    F90MODPROC( pggraph_mod, pgsfs1)(&type);

}


/********************************************************************
*
*
*********************************************************************/
void cbpgsci(int colour)
{
    F90MODPROC( pggraph_mod, pgsci1)(&colour);

}

/******************************************************************
*
*
*****************************************************************/
void cbpgbox(const char *xformat, float x, int k1, const char *yformat, float y, int k2)
{


    setParameter("plotfile", xformat);

    F90MODPROC( pggraph_mod, setxboxformat)();
    
  

    setParameter("plotfile", yformat);

    F90MODPROC( pggraph_mod, setyboxformat)();

 

    F90MODPROC( pggraph_mod, pgbox1)(&x, &k1, &y, &k2);




}










int symbol = -1;  //dot,  5=Cross
int colour = 1;




void setColour(int col)
{
  colour = col;
}

void setSymbol(int col)
{
  symbol = col;
}

int getColour() { return colour; };
int getSymbol() { return symbol; };









#include <f90cxx.h>











/****************************************
! SetUpColourIndice
! Colour indices used to plot fits regions
!***************************************/
void SetUpColourIndices()
{

 

    cbpgscr(1,  0.0, 1.0, 1.0);                   // Cyan
    cbpgscr(2,  1.0, 0.0, 1.0);                   // Magenta
    cbpgscr(3,  1.0, 1.0, 0.0);                   // Yellow
    cbpgscr(4,  0.0, 128.0/255.0, 128.0/255.0);   // Dark cyan
    cbpgscr(5,  0.0, 0.0, 128.0/255.0);           // Dark blue
    cbpgscr(6,  128.0/255.0, 128.0/255.0, 0.0);   // Dark yellow
    cbpgscr(7,  0.0, 128.0/255.0, 0.0);           // Dark green
    cbpgscr(8,  128.0/255.0, 0.0, 128.0/255.0);   // Dark magenta
    cbpgscr(9,  128.0/255.0, 0.0, 0.0);           // Dark red

    
    cbpgscr(10, 0.0, 0.0, 0.0);               // Black
    
    cbpgscr(11, 1.0, 0.0, 0.0);                 // Red for background mask

}

/****************************************
! SetUpColourIndice
! Colour indices used to plot fits regions
!***************************************/
void SetUpDefaultColourIndices( )
{

 
    cbpgscr(1,  0.0, 0.0, 0.0);                   // black

    cbpgscr(2,  1.0, 0.0, 0.0);                   // red
    cbpgscr(3,  0.0, 0.0, 1.0);                   // blue
    cbpgscr(4,  0.0, 1.0, 0.0);                   // green

    cbpgscr(5,  204.0/255.0, 0.0, 1.0);                   // green


    //    cpgscr(5,  0.0, 1.0, 1.0);                   // Cyan
    cbpgscr(6,  1.0, 0.0, 1.0);                   // Magenta
    cbpgscr(7,  1.0, 1.0, 0.0);                   // Yellow
    cbpgscr(8,  0.0, 128.0/255.0, 128.0/255.0);   // Dark cyan
    cbpgscr(9,  0.0, 0.0, 128.0/255.0);           // Dark blue
    cbpgscr(10,  128.0/255.0, 128.0/255.0, 0.0);   // Dark yellow
    cbpgscr(11,  0.0, 128.0/255.0, 0.0);           // Dark green
    cbpgscr(12,  128.0/255.0, 0.0, 128.0/255.0);   // Dark magenta
    cbpgscr(13,   128.0/255.0, 0.0, 0.0);           // Dark red

    cbpgscr(14,   1.0, 1.0, 1.0);           // white


}



/****************************************************
*
*
****************************************************/
void convert(float xData, float ydata, float &x, float &y)
{
  
    float alpha2, delta, r2, f, cdec, denom;


    alpha2 = xData / (2.0 * radiansToDegrees);
    delta = ydata / radiansToDegrees;
    r2 = sqrt( 2.0 );
    f = 2.0 * r2 / M_PI;

    cdec = cos(delta);
    denom = sqrt(1.0 + cdec * cos(alpha2));

    x = cdec * sin(alpha2) * 2.0 * r2 / denom;
    y = sin(delta) * r2 / denom;

    x = x * radiansToDegrees / f;
    y = y * radiansToDegrees / f;

}












/****************************************************************
*
*
* Several graphs on top of one another
*
*
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                vector< vector<float> > &dyData,
                vector<int>  &colourIndex,
                vector<string> &subTitle, 
                char *xlabel,
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                vector<float> &yMin, 
                vector<float> &yMax,
                bool equalAxes,
                float dw1, float dw2)
  
{
 
  //  cout << "graph.cc line 1481- drawgraph, ngraphs=" << ngraphs << endl;
  
    float y1 = 0.1;  
   

       
    float xmin =  10000.0;
    float xmax = -10000.0;
    float dw = dw1;
 


    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }
    else
    {
        for (int i = 0; i < ngraphs; i++)             
        {
           
            for (unsigned j = 0; j <  xdata[i].size(); j++)
            {
        
                if (xdata[i][j] < xmin) xmin = xdata[i][j];
                if (xdata[i][j] >  xmax) xmax = xdata[i][j];
	    }

        }
     
        cbpgrnge(xmin, xmax, &xmin, &xmax);

 
        
    }				  


   

    /***********************************************************
    *
    *
    ************************************************************/



    Graph::x1List.clear();
    Graph::x2List.clear();
    Graph::y1List.clear();
    Graph::y2List.clear();
  
    Graph::xminList.clear();
    Graph::xmaxList.clear();
    Graph::yminList.clear();
    Graph::ymaxList.clear();


    int k = 1;

    bool drawYAxesNumbersOnLeft = false;
    if(dw2 > 0.001)
    {
        drawYAxesNumbersOnLeft = true;
    }

    for (int i = 0; i < ngraphs; i++)                 
    {


        if( dw2 < 0.001)
        {
            drawYAxesNumbersOnLeft =  !drawYAxesNumbersOnLeft;
        }
        cbpgsci(1); 
     
     

        float y11 = y1 + float(k - 1) * dw + float(i) * dw2;;
        float y22 = y1 + float(k) * dw + float(i) * dw2;

	//       if (y22 > 0.9) // Start new page
	//	{
	//    k = 1;
        //    y11 = y1;
        //    y22 = y1 + dw;
        //    drawYAxesNumbersOnLeft = true;

        //    cbpgsch(0.8);
        //    cbpgmtxt("T", 1, 0.5, 0.5, title);
        //    cbpgpage();
        //    cout << "Line 1572 calling cbpage\n";

	// }
        


	k++;
    


        /**************************************************************************
	*
        * Store the graph origins and scales for possible later use
        *
        **************************************************************************/

        Graph::x1List.push_back( x1 );
        Graph::x2List.push_back( x2 );

        Graph::y1List.push_back( y11 );
        Graph::y2List.push_back( y22 );

        cbpgsvp(x1, x2, y11, y22);
      
     
      
        if (equalAxes)
        { 
	    cbpgwnad(xmin, xmax, yMin[i], yMax[i]);
        }
        else
        {
            cbpgswin(xmin, xmax, yMin[i], yMax[i]);
        
        }


        Graph::xminList.push_back( xmin );
        Graph::xmaxList.push_back( xmax );

        Graph::yminList.push_back( yMin[i] );
        Graph::ymaxList.push_back( yMax[i] );

      
        cbpgsls(1);


        cbpgsch(0.7);
        cbpgslw(3);
  
        /*************************************************************
	*
        * Draw the actual axes here
        *
	**************************************************************/

        if (k == 2) // The bottom graph
	{

	          
            cbpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
            cbpgbox("n", 0.0, 0, "nv", 0.0, 0);
            cbpgsch(1.0); 
	    //        cpglab("", ylabel, "");
            cbpgmtxt("L", 3.0, 0.5, 0.5, ylabel );


            cbpgmtxt("B", 2.5, 0.5, 0.5, xlabel );

        }
   
        else       // The graphs above it
	{
	   
            cbpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
         
      
            if ( drawYAxesNumbersOnLeft )
	    {       
                cbpgbox("", 0.0, 0, "nv", 0.0, 0);
                cbpgsch(1.0);  
 
                
                cbpgmtxt("L", 3.0, 0.5, 0.5, ylabel );


          
            }
            else
	    {
                cbpgbox("", 0.0, 0, "mv", 0.0, 0);
                cbpgsch(1.0); 
                cbpgmtxt("R", 2.0, 0.5, 0.5, ylabel);
           

            }

        }      
        cbpgsch(0.8);
      
        cbpgmtxt("T", -1, 0.0, 0.0, subTitle[i].c_str());
  
        cbpgslw(5);
  
           
        cbpgsch(1.2);
        int nData = xdata[i].size();           
       
         
        for (int j = 0; j < nData; j++)
	{
	  
	    cbpgsci(colourIndex[i] );
	   

            cbpgslw(10);
            cbpgpt1( xdata[i][j], ydata[i][j], symbol);

            cbpgsci(1);
            cbpgslw(2);

	    cbpgerr1(6, xdata[i][j], ydata[i][j], dyData[i][j], 2);
	    
        }
                
       
        cbpgsci(1);
          
        cbpgslw(1);
        cbpgsch(0.5);

    }  // End of this plot

    cbpgsch(1.2);
    cbpgmtxt("T", 1, 0.5, 0.5, title);
  


}

