! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!***************************************************************************!
! An interface to pgpltotext
!
!**************************************************************************

module pggraph_mod
use dal
use param
    integer, parameter, private :: size = 512

    character(size), private :: thelabel, xlabel, ylabel, title
    character(size), private :: xboxformat, yboxformat, textposition
  


public
contains

!subroutine test2(text1, text2, length)
    
!    integer, intent(in) :: length 
!    character(length), intent(in) :: text1
!    character(length), intent(in) :: text2


 
!    write(*, *) "length=", length     
!    write(*, *) "text1=", text1
!    write(*, *) "text2=", text2
 

!end subroutine test2

!************************************************************
!
!
!
!************************************************************


integer function pgopen1()
   
   
    character(size) :: name
  
    name = trim( stringParameter( "plotfile" ) )
   

    !*******************************************************
    ! Draw graphs for point-source detection
    !*******************************************************
    call pgbegin(0, name, 1, 1)

!write(*, *) "Line 51"    

    pgopen1 = 1

end function pgopen1



!***************************************************************
!
!
!
!***************************************************************
subroutine settextposition()
    
    textPosition = trim(stringParameter( "plotfile" ) )

  

end subroutine settextposition



!***************************************************************
!
!
!
!***************************************************************
subroutine setlabel()


    thelabel = trim(stringParameter( "plotfile" ) )



end subroutine setlabel


!***************************************************************
!
!
!
!***************************************************************
subroutine pgmtxt1( x1, x2, x3)
    real(single), intent(in) :: x1, x2, x3
    
!write(*, *) "pgmtxt1 line 94 textposition=", trim(textposition), " label=", trim(thelabel)

    call pgmtxt( trim(textposition), x1, x2, x3, trim(thelabel))

!write(*, *) "pgmtxt1 line 97"


end subroutine pgmtxt1

!***************


!***************************************************************
!
!
!
!***************************************************************
subroutine setxlabel()

    xlabel = trim(stringParameter( "plotfile" ) )


end subroutine setxlabel

!***************************************************************
!
!
!
!***************************************************************
subroutine setylabel()

    ylabel = trim(stringParameter( "plotfile" ) )



end subroutine setylabel


!***************************************************************
!
!
!
!***************************************************************
subroutine settitle()

    title = trim(stringParameter( "plotfile" ) )


end subroutine settitle



!***************************************************************
!
!
!
!***************************************************************
subroutine pglab1()

!write(*, *) "pglab1 line 171 xlabel=", trim(xlabel), " ylabel=", trim(ylabel), &
!   " title=", trim(title)

    call pglab( xlabel, ylabel, title )

!write(*, *) "Line 176"
end subroutine pglab1




!***************************************************************
!
!
!
!***************************************************************
subroutine setxboxformat()

    xboxformat = trim(stringParameter( "plotfile" ) )


end subroutine setxboxformat


!***************************************************************
!
!
!
!***************************************************************
subroutine setyboxformat()

    yboxformat = trim(stringParameter( "plotfile" ) )


end subroutine setyboxformat

!***************************************************************
!
!
!
!***************************************************************
subroutine pgbox1(x, k1, y, k2)
    real(single), intent(in) :: x, y
    integer, intent(in) :: k1, k2


   call pgbox(xboxformat, x, k1, yboxformat, y, k2)

end subroutine pgbox1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgmove1(x, y)
    real(single), intent(in) :: x, y
   
   call pgmove(x, y)

end subroutine pgmove1
!***************************************************************
!
!
!
!***************************************************************
subroutine pgdraw1(x, y)
    real(single), intent(in) :: x, y
   
   call pgdraw(x, y)

end subroutine pgdraw1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgcirc1(x, y, radius)
    real(single), intent(in) :: x, y, radius
   
   call pgcirc(x, y, radius)

end subroutine pgcirc1








!***************************************************************
!
!
!
!***************************************************************
real(single) function  pgrnd1(x, y)
    real(single), intent(in) :: x
    integer :: y, k
    k = y
   
   pgrnd1 = ceiling(x * 10000.0) / 100000.0

end function pgrnd1



!***************************************************************
!
!
!
!***************************************************************
subroutine pgrect1(x1, x2, y1, y2)
    real(single), intent(in) :: x1, x2, y1, y2
   
   call pgrect(x1, x2, y1, y2)

end subroutine pgrect1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgclos1()

    call pgclos()

end subroutine pgclos1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgpage1()

    call pgpage()

end subroutine pgpage1


!***************************************************************
!
!
!
!***************************************************************
subroutine pgsvp1(x1, x2, y1, y2)
    real(single), intent(in) :: x1, x2, y1, y2
    call pgsvp(x1, x2, y1, y2)

end subroutine pgsvp1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgswin1(x1, x2, y1, y2)
    real(single), intent(in) :: x1, x2, y1, y2
    call pgswin(x1, x2, y1, y2)

end subroutine pgswin1
!***************************************************************
!
!
!
!***************************************************************
subroutine pgwnad1(x1, x2, y1, y2)
    real(single), intent(in) :: x1, x2, y1, y2

!write(*, *) "pgwnad1 x1=", x1, " x2=", x2, " y1=", y1, " y2=", y2
    call pgwnad(x1, x2, y1, y2)

end subroutine pgwnad1


!***************************************************************
!
!
!
!***************************************************************
subroutine pgrnge1(x1, y1, x2, y2)
    real(single), intent(inout) :: x1, x2, y1, y2
    call pgrnge(x1, x2, y1, y2)

end subroutine pgrnge1


!***************************************************************
!
!
!
!***************************************************************
subroutine pgline1(nData, x, y)
    integer, intent(in) :: nData
    real(single), dimension(1 : nData) :: x, y
    integer :: i

    do i = 2, nData
        call pgmove(x(i - 1), y(i - 1))
        call pgdraw(x(i), y(i))
    end do

!    call pgline(nData, x, y)
 

end subroutine pgline1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgpt11(nData, x, y, symbol)
    integer, intent(in) :: nData, symbol
    real(single), dimension(1 : ndata) :: x, y

!write(*, *) "pgpt11 ndata=", ndata, " symbol=", symbol
!write(*, *) "lbound x=", lbound(x), " ubound=", ubound(x)
!write(*, *) "lbound y=", lbound(y), " ubound=", ubound(y)


    call pgpt(nData, x, y, symbol)
! write(*, *) "leaving pgpt11"
end subroutine pgpt11


!***************************************************************
!
!
!
!***************************************************************
subroutine pgpt111(xData1, ydata1, symbol)
    integer, intent(in) :: symbol
    real(single) :: xdata1, ydata1
    real(single), dimension(1) :: x(1), y(1)
 
    x(1) = xdata1
    y(1) = yData1

    call pgpt(1, x, y, symbol)
 
end subroutine pgpt111






!***************************************************************
!
!
!
!***************************************************************
subroutine pgerr11(k, xData, ydata, xerror, k1)
    integer, intent(in) :: k, k1
    real(single) :: xdata, ydata, xerror

  


    call pgerr1(k, xData, yData, xerror, real(k1))

end subroutine pgerr11

!***************************************************************
!
!
!
!***************************************************************
subroutine pgerrx1(ndata, xdata1, ydata1, xerrors, k)
    integer, intent(in) :: ndata, k
    real(single) :: xdata1(:), ydata1(:), xerrors

    call pgerrx(ndata, xData1, yData1, xerrors, real(k))
  
end subroutine pgerrx1

!***************************************************************
!
!
!
!***************************************************************
subroutine pgerry1(ndata, xdata1, ydata1, xerrors, k)
    integer, intent(in) :: ndata, k
    real(single) :: xdata1(:), ydata1(:), xerrors

    call pgerry(ndata, xData1, yData1, xerrors, real(k))
  
end subroutine pgerry1

!****************************************************************
!
!
!*****************************************************************
subroutine pgschi1(size)
    real(single), intent(in) :: size

    call pgsch(size)

end subroutine pgschi1      
  



!****************************************************************
!
!
!*****************************************************************
subroutine pgsls1(style)
    integer, intent(in) :: style

    call pgsls(style)

end subroutine pgsls1 

!****************************************************************
!
!
!*****************************************************************
subroutine pgslw1(width)
    integer, intent(in) :: width

    call pgslw(width)

end subroutine pgslw1 





!****************************************************************
!
!
!*****************************************************************
subroutine pgsfs1(type)
    integer, intent(in) :: type

    call pgsfs(type)

end subroutine pgsfs1 

!****************************************************************
!
!
!*****************************************************************
subroutine pgsci1(colour)
    integer, intent(in) :: colour

    call pgsci(colour)
end subroutine pgsci1










!**************************************************************************
!
!
!*************************************************************************
subroutine pghist1(ndata, xdata, xmin, xmax, nobins, type)
    integer, intent(in) :: ndata
    real(single), intent(in) :: xdata(1 : ndata), xmin, xmax
    integer, intent(in) :: nobins, type 


    call pghist(nData, xData, xmin, xmax, noBins, type)

end subroutine pghist1











!**************************************************************************
!
!
!*************************************************************************
subroutine pgscr1(k, c1, c2, c3)
    integer, intent(in) :: k
    real(single), intent(in) :: c1, c2, c3
   

    call pgscr(k, c1, c2, c3)

end subroutine pgscr1



!**************************************************************************
!
!
!*************************************************************************
subroutine pgsubp1(nx, ny)
    integer, intent(in) :: nx, ny
   

    call pgsubp(nx, ny)

end subroutine pgsubp1


!**************************************************************************
!
!
!*************************************************************************
subroutine pgpanl1(nx, ny)
    integer, intent(in) :: nx, ny
   

    call pgpanl(nx, ny)

end subroutine pgpanl1







end module pggraph_mod
